/*********************************************************************
MODULE:         pbitdraw.h

PROGRAMMERS:    John White and Yaoen Zhang

DESCRIPTION:    It contains various various constants used in 
		editing the tile patterns.
*****************************************************************/
#define TILE_DIM 8		/* global constants used in tile*/
#define SET 1
#define NOT_SET 0
#define NOWRITE -1
#define SQUARE_SIZE 25
#define X_TILE_OFFSET 15
#define Y_TILE_OFFSET 25
#define X_VIEW_OFFSET 10 
#define Y_VIEW_OFFSET 13
#define X_TILE_MAX 190 
#define Y_TILE_MAX 200 
#define RIM_WIDTH 2 
#define MAX_TEXTURE_MAPS 6
				/* specifying the 6_face tile */
typedef int Tile_type[TILE_DIM][TILE_DIM];
Tile_type tile[MAX_TEXTURE_MAPS];

typedef struct {
	Widget target;		/* tile editing window */
	Widget w1, w2;		/* tile pattern showing window*/
 	Widget help;		/* help message window */
        Widget tileview;	/* tile view window on main win*/
	GC	gc1, gc2;	/* graphics context */
        Tile_type  tmp_tile;
	Display  *w1_display, *w2_display;
	Window    w1_window, w2_window;
        int write;		/* flags to prevent leave without*/
        int color_flag;		/* writing   			 */
} Info;

